//+------------------------------------------------------------------+
//|                                                    !NeuroInd.mq4 |
//|                                Copyright  2008,   |
//+------------------------------------------------------------------+

#property indicator_separate_window

#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 1

int NUM_MA=10;
int DEPTH_MA=11;

double Target[];//    -   

int nIN=0; //   
int nOUT=0;	//  
int nLayer=0;	//  
int nNeuron[10];	//    
// 
double W[10][100][100]; //  
double Thresh[10][100]; //  
double Out[10][100];		//  
//   
double MaIn[10][11]; //    

//------------------------------------------------------------------ Sigmoid
double Sigmoid(double x) 
{ 
	double rez=1/(1+MathExp(-x)); 
	return(rez); 
}
//------------------------------------------------------------------ init
int init()	
{  
	SetIndexBuffer(0,Target); SetIndexStyle(0,DRAW_LINE); 
	return(0);  
}
//------------------------------------------------------------------ deinit
int deinit() { return(0); }
//------------------------------------------------------------------ GetWeight
void GetWeight() //    
{
	int j,i, k;
	string FileName = "eurusd_15.wgh";	int hFile = FileOpen(FileName, FILE_READ|FILE_BIN);
	FileSeek(hFile, 0, SEEK_SET);
	nIN = FileReadInteger(hFile); //   
	nOUT = FileReadInteger(hFile); //  
	nLayer = FileReadInteger(hFile);//  	
	//    
	for (k=0; k<nLayer; k++) nNeuron[k]=FileReadInteger(hFile);

	//      
	for(k=1; k<nLayer;k++)  //   ,    L[1] (L[0] -   )
		for(i=0; i<nNeuron[k];i++) 
		{
			for(j=0; j<nNeuron[k-1];j++) W[k][i][j]=FileReadDouble(hFile);
			Thresh[k][i]=FileReadDouble(hFile);
		}
	FileClose(hFile);
}
//------------------------------------------------------------------ CalculateNetwork
void CalculateNetwork() //   
{
	int i,j, k;
	double sum=0;
	for(k=1; k<nLayer;k++) //   ,    L[1] (L[0] -   )
		for(i=0;i<nNeuron[k];i++) //  
		{ 
			sum=0;
			for(j=0; j<nNeuron[k-1]; j++) sum+=W[k][i][j]*Out[k-1][j];
			Out[k][i]=Sigmoid(sum+Thresh[k][i]);
		}
}
//------------------------------------------------------------------ start
int start() 
{
	Print(" ");
	GetWeight(); //     

	Print(" ");
	//      :)
	// !!!   50 ,      !!!
	int i, ma, depth, k;
	double op;
	for (i=5000; i>0; i--) //         
	{
		for (depth=0; depth<DEPTH_MA; depth++) //  
			for (ma=0; ma<NUM_MA; ma++) 
				MaIn[ma][depth]=iMA(NULL, 0, 2+ma*3, 0, MODE_EMA, PRICE_MEDIAN, i+depth*3);

		for (depth=0; depth<DEPTH_MA; depth++) //   
		{
			op=(High[i+depth*3]+Low[i+depth*3])/2.0; 
			for (ma=0; ma<NUM_MA; ma++) MaIn[ma][depth]-=op;
		}
		k=0;
		for (ma=0; ma<NUM_MA; ma++) //   
		{
			for (depth=0; depth<DEPTH_MA-1; depth++) 
			{
				MaIn[ma][depth]-=MaIn[ma][depth+1];
				op=MathArctan(MaIn[ma][depth]/(5*Point))/3.141592653589793238642463+0.5;
				Out[0][k]=op; k++;	//   
				if (k>=nNeuron[0])	break;
			}
			if (k>=nNeuron[0])	break;
		}
		CalculateNetwork();
		Target[i]=Out[nNeuron[nLayer-1]][0];
	}
	return(0);
}

